--- calc_73.c.old	2013-03-29 07:50:08.000000000 -0500
+++ calc_73.c	2014-06-26 14:18:21.167271609 -0500
@@ -456,21 +456,32 @@
 	int i, j, k;
 	int size;
 	char *utf8;
-	int se = 0;
+	int cpu15mhz = 0;
 
 	// search for data header
 	for (ptr = content; ptr != NULL; ptr = ptr->next)
+	{
 		if(ptr->data_type == TI83p_AMS || ptr->data_type == TI83p_APPL)
+		{
 			break;
+		}
+	}
+	
 	if(ptr == NULL)
 		return -1;
 
 	if(ptr->data_type == TI83p_AMS)
+	{
 		size = 0x100;
+	}
 	else if(ptr->data_type == TI83p_APPL)
+	{
 		size = 0x80;
+	}
 	else
+	{
 		return -1;
+	}
 
 	// check for 83+ Silver Edition (not usable in boot mode, sic!)
 	if(handle->model != CALC_TI73 && ptr->data_type == TI83p_APPL)
@@ -478,7 +489,13 @@
 		CalcInfos infos;
 
 		TRYF(get_version(handle, &infos));
-		se = infos.hw_version & 1;
+		cpu15mhz = infos.hw_version & 1;
+
+		if (!infos.battery)
+		{
+			ticalcs_info(_("Battery low, stopping flash app transfer"));
+			return -1;
+		}
 	}
 
 
@@ -523,17 +540,22 @@
 		}
 
 		/* Note: 
-			TI83+/SE and TI84+/SE don't need a pause (otherwise transfer fails).
-			TI73,TI83+,TI84+ need a pause (otherwise transfer fails).
+			TI83+SE, TI84+ and TI84+SE don't need a pause (otherwise transfer fails).
+			TI73 and TI83+ need a pause (otherwise transfer fails).
+			Delay also causes OS transfers to fail on the 15Mhz calcs and unneeded for OS's
 		*/
-		if(!se)
+		if(!cpu15mhz && ptr->data_type == TI83p_APPL)
 		{
 			if (i == 1)
+			{
 			  PAUSE(1000);		// This pause is NEEDED !
+			}
 			if (i == ptr->num_pages - 2)
+			{
 			  PAUSE(2500);		// This pause is NEEDED !
+           }
        }
 	}
 
 	TRYF(ti73_send_EOT(handle));
 	TRYF(ti73_recv_ACK(handle, NULL));
